def vrai (v):
    def vrai_ (f):
        return v
    return vrai_

def faux (v):
    def faux_ (f):
        return f
    return faux_

def si (c):
    def si_ (v):
        def si__ (f):
            return c(v)(f)
        return si__
    return si_

def et (a):
    def et_ (b):
        return si(a)(b)(faux)
    return et_

def ou (a):
    def ou_ (b):
        return si(a)(vrai)(b)
    return ou_

def non (a):
    return si(a)(faux)(vrai)

def zero (f):
    def zero_ (x):
        return x
    return zero_

def succ (n):
    def n_plus_1 (f):
        def n_plus_1_ (x):
            return f(n(f)(x))
        return n_plus_1_
    return n_plus_1

def add (n):
    def add_ (m):
        def sum (f):
            def sum_ (x):
                return m(f)(n(f)(x))
            return sum_
        return sum
    return add_

def mul (n):
    def mul_ (m):
        def prod (f):
            def prod_ (x):
                return m(n(f))(x)
            return prod_
        return prod
    return mul_

def is_zero (n):
    def faux_ (_):
        return faux
    return n(faux_)(vrai)

def pred (n):
    def n_minus_1 (f):
        def n_minus_1_ (x):
            def ign (_):
                return x
            def id (a):
                return a
            def ign1 (m):
                def ign1_ (g):
                    return g(m(f))
                return ign1_
            return n(ign1)(ign)(id)
        return n_minus_1_
    return n_minus_1

def sub (n):
    def sub_ (m):
        return m(pred)(n)
    return sub_

un = succ(zero)
deux = succ(un)
trois = succ(deux)
quatre = succ(trois)
cinq = add(deux)(trois)
six = mul(deux)(trois)
sept = succ(six)
huit = mul(deux)(quatre)

def gte (n):
    def gte_ (m):
        return is_zero(sub(m)(n))
    return gte_

def gt (n):
    def gt_ (m):
        return is_zero(sub(succ(m))(n))
    return gt_

def lt (n):
    def lt_ (m):
        return non(gte(n)(m))
    return lt_

def lte (n):
    def lte_ (m):
        return non(gt(n)(m))
    return lte_

def eq (n):
    def eq_ (m):
        return et(gte(n)(m))(lte(n)(m))
    return eq_

def cons (a):
    def cons_ (b):
        def cons__ (c):
            def pair (n):
                return c(a)(b)
            return pair
        return cons__
    return cons_

def car (p):
    return p(vrai)("error: car")

def cdr (p):
    return p(faux)("error: cdr")

def nil (c):
    def nil_ (n):
        return n(n)
    return nil_

def is_null (p):
    def f (a):
        def f_ (b):
            return faux
        return f_
    def v (n):
        return vrai
    return p(f)(v)

def is_pair (p):
    def v (a):
        def v_ (b):
            return vrai
        return v_
    def f (n):
        return faux
    return p(v)(f)

def Y (f):
    def Y_ (y):
        def Y__ (a):
            return y(y)(a)
        return f(Y__)
    return Y_(Y_)

def num (n):
    def add1 (n):
        return n+1
    return n(add1)(0)

def bool (b):
    return b(True)(False)

def lst (l, t):
    res = []
    while not bool(is_null(l)):
        res.append(t(car(l)))
        l = cdr(l)
    return res
